using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.Stratus;

#nullable enable

internal class Row
{

    public Row(Run run, int index, int i, int j)
    {
        Index = index;
        //
        Batch = run.Header.Batch;
        Cassette = run.Header.Cassette;
        DateTime = run.Header.DateTime;
        //
        Destination = run.Wafers[i].Destination;
        Mean = run.Wafers[i].Mean;
        PassFail = run.Wafers[i].PassFail;
        Recipe = run.Wafers[i].Recipe;
        Reference = run.Wafers[i].Reference;
        Site = run.Wafers[i].Sites[j];
        Slot = run.Wafers[i].Slot;
        Source = run.Wafers[i].Source;
        StdDev = run.Wafers[i].StdDev;
        Text = run.Wafers[i].Text;
        //
        GradeMean = run.Grade.MeanThickness;
        GradeStdDev = run.Grade.StdDev;
    }

    public int Index { get; }
    //
    public string Batch { get; }
    public string Cassette { get; }
    public string DateTime { get; }
    //
    public string Destination { get; }
    public string Mean { get; }
    public string PassFail { get; }
    public string Recipe { get; }
    public string Reference { get; }
    public string Site { get; }
    public string Slot { get; }
    public string Source { get; }
    public string StdDev { get; }
    public string Text { get; }
    //
    public string GradeMean { get; }
    public string GradeStdDev { get; }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Row))]
internal partial class StratusRowSourceGenerationContext : JsonSerializerContext
{
}