"use strict";

// getValue($('gv.thicknessMeanSlotOne', ''), $('dcp.BIORAD5/csv/Count', ''), $('dcp.BIORAD5/csv/Index', ''), $('dcp.BIORAD5/csv/Slot', ''), $('dcp.BIORAD5/csv/Mean', ''));

function getValue5(thicknessMeanSlotOne, count, index, slot, mean) {
    let result = null;
    if (count !== 2 || index !== 0 || slot !== '1' || mean == '')
        result = thicknessMeanSlotOne;
    else
        result = mean;
    return result;
}

const values14 = [
    { count: 2, index: 0, slot: '1', mean: '1.23', result: '1.23' },
    { count: 3, index: 0, slot: '1', mean: '1.23', result: '' },
    { count: 2, index: 1, slot: '1', mean: '1.23', result: '' },
    { count: 2, index: 0, slot: '2', mean: '1.23', result: '' },
];

values14.forEach(element => {
    let result = getValue5(element.count, element.index, element.slot, element.mean);
    if (result != element.result)
        console.error("result doesn't match!");
    else
        console.info('Match');
});

// getValue($('gv.thicknessMeanSlotTwentyFive', ''), $('dcp.BIORAD5/csv/Count', ''), $('dcp.BIORAD5/csv/Index', ''), $('dcp.BIORAD5/csv/Slot', ''), $('dcp.BIORAD5/csv/Mean', ''));

function getValue31(thicknessMeanSlotTwentyFive, count, index, slot, mean) {
    let result = null;
    if (count !== 2 || index !== 1 || slot !== '25' || mean == '')
        result = thicknessMeanSlotTwentyFive;
    else
        result = mean;
    return result;
}

const values40 = [
    { count: 2, index: 1, slot: '25', mean: '1.23', result: '1.23' },
    { count: 3, index: 0, slot: '25', mean: '1.23', result: '' },
    { count: 2, index: 0, slot: '25', mean: '1.23', result: '' },
    { count: 2, index: 0, slot: '24', mean: '1.23', result: '' },
];

values40.forEach(element => {
    let result = getValue31(element.count, element.index, element.slot, element.mean);
    if (result != element.result)
        console.error("result doesn't match!");
    else
        console.info('Match');
});

// getValue($('dcp.BIORAD5/csv/Count', ''), $('dcp.BIORAD5/csv/Index', ''), $('dcp.BIORAD5/csv/Slot', ''), $('gv.thicknessMeanSlotOne', ''), $('gv.thicknessMeanSlotTwentyFive', ''));

function getValue57(count, index, slot, thicknessMeanSlotOne, thicknessMeanSlotTwentyFive) {
    let result = null;
    if (count !== 2 || index !== 1 || slot !== "25" || thicknessMeanSlotOne == '' || thicknessMeanSlotTwentyFive == '')
        result = '';
    else
        result = Math.round((parseFloat(thicknessMeanSlotOne) - parseFloat(thicknessMeanSlotTwentyFive)) * 1000) / 1000;
    return result;
}

const values66 = [
    { count: 2, index: 1, slot: '25', thicknessMeanSlotOne: '9.163', thicknessMeanSlotTwentyFive: '9.112', result: '0.051' },
    { count: 3, index: 0, slot: '25', thicknessMeanSlotOne: '9.163', thicknessMeanSlotTwentyFive: '9.112', result: '' },
    { count: 2, index: 0, slot: '25', thicknessMeanSlotOne: '9.163', thicknessMeanSlotTwentyFive: '9.112', result: '' },
    { count: 2, index: 0, slot: '24', thicknessMeanSlotOne: '9.163', thicknessMeanSlotTwentyFive: '9.112', result: '' },
];

values66.forEach(element => {
    let result = getValue57(element.count, element.index, element.slot, element.thicknessMeanSlotOne, element.thicknessMeanSlotTwentyFive);
    if (result != element.result)
        console.error("result doesn't match!");
    else
        console.info('Match');
});

// getValue($('dcp.BIORAD5/csv/Count', ''), $('dcp.BIORAD5/csv/Index', ''), $('dcp.BIORAD5/csv/Slot', ''), $('gv.thicknessMeanSlotOne', ''), $('gv.thicknessMeanSlotTwentyFive', ''));

function getValue(count, index, slot, thicknessMeanSlotOne, thicknessMeanSlotTwentyFive) {
    let result = null;
    if (count !== 2 || index !== 1 || slot !== "25" || thicknessMeanSlotOne == '' || thicknessMeanSlotTwentyFive == '')
        result = '';
    else {
        const thick01 = parseFloat(thicknessMeanSlotOne);
        const thick25 = parseFloat(thicknessMeanSlotTwentyFive);
        const percent = Math.abs(thick01 - thick25) / ((thick01 + thick25) / 2) * 100;
        result = (Math.round(percent * 1000)) / 1000;
    }
    return result;
}

const values92 = [
    { count: 2, index: 1, slot: '25', thicknessMeanSlotOne: '9.163', thicknessMeanSlotTwentyFive: '9.112', result: '0.558' },
    { count: 3, index: 0, slot: '25', thicknessMeanSlotOne: '9.163', thicknessMeanSlotTwentyFive: '9.112', result: '' },
    { count: 2, index: 0, slot: '25', thicknessMeanSlotOne: '9.163', thicknessMeanSlotTwentyFive: '9.112', result: '' },
    { count: 2, index: 0, slot: '24', thicknessMeanSlotOne: '9.163', thicknessMeanSlotTwentyFive: '9.112', result: '' },
];

values92.forEach(element => {
    let result = getValue(element.count, element.index, element.slot, element.thicknessMeanSlotOne, element.thicknessMeanSlotTwentyFive);
    if (result != element.result)
        console.error("result doesn't match!");
    else
        console.info('Match');
});